=== debian/changelog ===
mpg123 (1.32.5-1ubuntu1) noble; urgency=medium

  [ Steve Langasek ]
  * Rename libraries for 64-bit time_t transition. (Closes: #1063140)

  [ Simon Chopin ]
  * Only include 32bit compat symbols on i386 arches (Closes: #1067562)

 -- Simon Chopin <schopin@ubuntu.com>  Wed, 03 Apr 2024 20:29:56 +0200

mpg123 (1.32.5-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:08:02 +0000

mpg123 (1.32.5-1build1) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 06:39:44 +0000

mpg123 (1.32.5-1) unstable; urgency=medium

  * New upstream version 1.32.5

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 24 Feb 2024 21:46:32 +0100

mpg123 (1.32.4-1) unstable; urgency=medium

  * New upstream version 1.32.4

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 21 Jan 2024 17:52:21 +0100

mpg123 (1.32.3-1) unstable; urgency=medium

  * New upstream version 1.32.3
  * debian/patches: Refresh patches
  * debian/libmpg123-dev.docs: Install all NEWS files
  * debian/: Remove kfreebsd-any
  * debian/*.symbols: Add new symbols

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 02 Oct 2023 21:42:56 +0200
