## mpg123 1.32.6

=== debian/changelog ===
mpg123 (1.32.6-3) unstable; urgency=medium

  * debian/*.symbols: Fix architectures (Closes: #1068623)
    Thanks to Christian Marillat.
  * debian/control: Bump Standards-Version

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 08 Apr 2024 23:05:29 +0200

mpg123 (1.32.6-2) unstable; urgency=medium

  * debian/: Fix symbols on armel and armhf
  * debian/rules: Use upstream recommended CPU settings for arm* architectures

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 05 Apr 2024 23:23:43 +0200

mpg123 (1.32.6-1) unstable; urgency=medium

  [ Sebastian Ramacher ]
  * New upstream version 1.32.6

  [ Steve Langasek ]
  * Rename libraries for 64-bit time_t transition. (Closes: #1063140)

  [ Simon Chopin ]
  * Only include 32bit compat symbols on i386 arches (Closes: #1067562)

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 05 Apr 2024 13:31:38 +0200
