## mpg123 1.32.7

=== debian/changelog ===
mpg123 (1.32.7-1ubuntu0.1) oracular-security; urgency=medium

  * SECURITY UPDATE: OOB write during PCM decoding
    - debian/patches/CVE-2024-10573-1.patch: don't prepare for actual frame
      data when there is none in src/libmpg123/parse.c.
    - debian/patches/CVE-2024-10573-2.patch: separate header data into a
      struct, ensure late updating in frame in src/libmpg123/frame.c,
      src/libmpg123/frame.h, src/libmpg123/layer1.c,
      src/libmpg123/layer2.c, src/libmpg123/layer3.c,
      src/libmpg123/libmpg123.c, src/libmpg123/parse.c.
    - CVE-2024-10573

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 04 Nov 2024 13:23:00 -0500

mpg123 (1.32.7-1) unstable; urgency=medium

  * New upstream version 1.32.7

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 11 Aug 2024 10:12:07 +0200
