=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
  Miguel A. Colón Vélez <debian.micove@gmail.com>,
  Sebastian Ramacher <sramacher@debian.org>
 Build-Depends:
+ dpkg-dev (>= 1.22.5),
  debhelper-compat (= 13),
  libasound2-dev [linux-any],
  libaudio-dev,
@@ -17,7 +18,7 @@
  libpulse-dev [!hurd-i386],
  pkgconf,
  portaudio19-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: http://mpg123.org/
 Vcs-Git: https://salsa.debian.org/multimedia-team/mpg123.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/mpg123
