## mpg123 1.32.8

=== debian/changelog ===
mpg123 (1.32.8-1deepin1) unstable; urgency=medium

  * revert t64 patch.

 -- lichenggang <lichenggang@deepin.org>  Thu, 31 Oct 2024 10:26:50 +0800

mpg123 (1.32.8-1) unstable; urgency=medium

  [ Bastian Germann ]
  * Generalize hurd-i386 to hurd-any

  [ Sebastian Ramacher ]
  * New upstream version 1.32.8

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 27 Oct 2024 19:48:21 +0100
