=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: mpg123
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Reinhard Tartler <siretart@tauware.de>,
  Miguel A. Colón Vélez <debian.micove@gmail.com>,
@@ -15,7 +14,7 @@
  libjack-dev,
  libltdl-dev,
  libopenal-dev,
- libpulse-dev [!hurd-i386],
+ libpulse-dev [!hurd-any],
  pkgconf,
  portaudio19-dev
 Standards-Version: 4.7.0
@@ -44,10 +43,7 @@
  OSS4, the Advanced Linux Sound Architecture (ALSA), JACK, PortAudio,
  PulseAudio, OpenAL and the Network Audio System (NAS).
 
-Package: libmpg123-0t64
-Provides: ${t64:Provides}
-Replaces: libmpg123-0
-Breaks: libmpg123-0 (<< ${source:Version})
+Package: libmpg123-0
 Multi-Arch: same
 Architecture: any
 Section: libs
@@ -61,10 +57,7 @@
  This package contains the C libraries needed to run executables that use
  the mpg123 library.
 
-Package: libout123-0t64
-Provides: ${t64:Provides}
-Replaces: libout123-0
-Breaks: libout123-0 (<< ${source:Version})
+Package: libout123-0
 Multi-Arch: same
 Architecture: any
 Section: libs
@@ -77,10 +70,7 @@
  .
  This package contains the shared out123 library.
 
-Package: libsyn123-0t64
-Provides: ${t64:Provides}
-Replaces: libsyn123-0
-Breaks: libsyn123-0 (<< ${source:Version})
+Package: libsyn123-0
 Multi-Arch: same
 Architecture: any
 Section: libs
@@ -98,9 +88,9 @@
 Architecture: any
 Section: libdevel
 Depends:
- libmpg123-0t64 (= ${binary:Version}),
- libout123-0t64 (= ${binary:Version}),
- libsyn123-0t64 (= ${binary:Version}),
+ libmpg123-0 (= ${binary:Version}),
+ libout123-0 (= ${binary:Version}),
+ libsyn123-0 (= ${binary:Version}),
  ${misc:Depends}
 Description: MPEG layer 1/2/3 audio decoder (development files)
  mpg123 is a real time MPEG 1.0/2.0/2.5 audio player/decoder for layers
