## mpg123 1.32.10

=== debian/changelog ===
mpg123 (1.32.10-1) unstable; urgency=medium

  [ Bastien Roucariès ]
  * Add salsa-ci

  [ Sebastian Ramacher ]
  * New upstream version 1.32.10
    - Use strtok_r for multi-threaded use (Closes: #1089543)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 22 Dec 2024 23:07:30 +0100

mpg123 (1.32.9-1) unstable; urgency=medium

  * New upstream release
    Fixes: CVE-2024-10573, Closes: #1086443

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 11 Nov 2024 06:46:18 -0500
