=== debian/control ===
--- 
+++ 
@@ -43,7 +43,10 @@
  OSS4, the Advanced Linux Sound Architecture (ALSA), JACK, PortAudio,
  PulseAudio, OpenAL and the Network Audio System (NAS).
 
-Package: libmpg123-0
+Package: libmpg123-0t64
+Provides: ${t64:Provides}
+Replaces: libmpg123-0
+Breaks: libmpg123-0 (<< ${source:Version})
 Multi-Arch: same
 Architecture: any
 Section: libs
@@ -57,7 +60,10 @@
  This package contains the C libraries needed to run executables that use
  the mpg123 library.
 
-Package: libout123-0
+Package: libout123-0t64
+Provides: ${t64:Provides}
+Replaces: libout123-0
+Breaks: libout123-0 (<< ${source:Version})
 Multi-Arch: same
 Architecture: any
 Section: libs
@@ -70,7 +76,10 @@
  .
  This package contains the shared out123 library.
 
-Package: libsyn123-0
+Package: libsyn123-0t64
+Provides: ${t64:Provides}
+Replaces: libsyn123-0
+Breaks: libsyn123-0 (<< ${source:Version})
 Multi-Arch: same
 Architecture: any
 Section: libs
@@ -88,9 +97,9 @@
 Architecture: any
 Section: libdevel
 Depends:
- libmpg123-0 (= ${binary:Version}),
- libout123-0 (= ${binary:Version}),
- libsyn123-0 (= ${binary:Version}),
+ libmpg123-0t64 (= ${binary:Version}),
+ libout123-0t64 (= ${binary:Version}),
+ libsyn123-0t64 (= ${binary:Version}),
  ${misc:Depends}
 Description: MPEG layer 1/2/3 audio decoder (development files)
  mpg123 is a real time MPEG 1.0/2.0/2.5 audio player/decoder for layers
