## mpg123 1.33.0

=== debian/changelog ===
mpg123 (1.33.0-1) experimental; urgency=medium

  * New upstream version 1.33.0
  * debian/control: Bump Standards-Version
  * debian/copyright: Bump copyright years
  * debian/libmpg123-0t64.symbols: Add new symbols

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 19 Jun 2025 18:39:33 +0200
