## mpg123 1.33.2

=== debian/changelog ===
mpg123 (1.33.2-1) unstable; urgency=medium

  * New upstream version 1.33.2
  * Upload to unstable

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 06 Aug 2025 12:30:09 +0200
