=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
  libpulse-dev [!hurd-any],
  pkgconf,
  portaudio19-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: http://mpg123.org/
 Vcs-Git: https://salsa.debian.org/multimedia-team/mpg123.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/mpg123
