=== debian/changelog ===
mpg123 (1.33.3-1) unstable; urgency=medium

  * New upstream version 1.33.3
  * debian/watch: Use version 5
  * debian/control:
    - Drop RRR: no
    - Remove no longer existing oss4-base from Suggests
  * debian/rules: Drop armel handling

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 10 Oct 2025 18:47:18 +0200
