=== debian/control ===
--- 
+++ 
@@ -14,14 +14,13 @@
  libjack-dev,
  libltdl-dev,
  libopenal-dev,
- libpulse-dev [!hurd-any],
+ libpulse-dev [linux-any],
  pkgconf,
  portaudio19-dev
 Standards-Version: 4.7.2
 Homepage: http://mpg123.org/
 Vcs-Git: https://salsa.debian.org/multimedia-team/mpg123.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/mpg123
-Rules-Requires-Root: no
 
 Package: mpg123
 Architecture: any
@@ -33,7 +32,6 @@
  jackd,
  nas,
  oss-compat [linux-any],
- oss4-base [linux-any],
  pulseaudio
 Description: MPEG layer 1/2/3 audio player
  mpg123 is a real time MPEG 1.0/2.0/2.5 audio player/decoder for layers
