=== debian/rules ===
--- 
+++ 
@@ -6,14 +6,10 @@
 
 WRAPPER_TARGETS:=mpg123-oss mpg123-nas mpg123-jack mpg123-openal mpg123-portaudio
 ifeq ($(DEB_HOST_ARCH_OS),linux)
-	WRAPPER_TARGETS += mpg123-alsa
-endif
-ifneq ($(DEB_HOST_ARCH_OS),hurd)
-	WRAPPER_TARGETS += mpg123-pulse
+	WRAPPER_TARGETS += mpg123-alsa mpg123-pulse
 endif
 
 CONF_i386:=--with-cpu=x86_dither
-CONF_armel:=--with-cpu=arm_nofpu
 CONF_armhf:=--with-cpu=arm_fpu
 CONF_arm64:=--with-cpu=aarch64
 
@@ -30,13 +26,10 @@
 		--includedir=\$${prefix}/include/$(DEB_HOST_MULTIARCH) \
 		$(CONF_$(DEB_HOST_ARCH))
 
-override_dh_auto_clean:
-	dh_auto_clean
+execute_after_dh_auto_clean:
 	rm -f $(WRAPPER_TARGETS)
 
-override_dh_auto_install: $(WRAPPER_TARGETS)
-	dh_auto_install
-
+execute_after_dh_auto_install: $(WRAPPER_TARGETS)
 	mv $(CURDIR)/debian/tmp/usr/bin/mpg123 \
 	   $(CURDIR)/debian/tmp/usr/bin/mpg123.bin
 	mv $(CURDIR)/debian/tmp/usr/share/man/man1/mpg123.1 \
