=== debian/watch ===
Version: 5

Source: https://sf.net/mpg123
Matching-Pattern: mpg123-@ANY_VERSION@@ARCHIVE_EXT@
Pgp-Sig-Url-Mangle: s/$/.sig/
